#!/usr/bin/env node
import u from "node:path";
import p from "node:fs";
import x from "lodash.upperfirst";
import h from "lodash.camelcase";
import y from "lodash.kebabcase";
import A from "lodash.lowerfirst";
import f from "lodash.template";
import { log as m, json5 as L, chalk as g, xPrompts as w, _curry as b, createSubcommand as M, createMainCommand as F } from "@done-coding/cli-utils";
import { OutputModeEnum as $, compileHandler as O } from "@done-coding/cli-template";
var a = /* @__PURE__ */ ((e) => (e.ADD = "add", e.REMOVE = "remove", e.LIST = "list", e))(a || {});
const T = (e, t) => {
  if (!/^[a-zA-Z]+[a-zA-Z0-9-]*$/.test(e))
    return m.error("组件名只能包含字母、数字、中划线"), process.exit(1);
  const { nameExcludes: n } = t;
  return n.includes(e) ? (m.error(`组件名: ${e}是保留名称。
保留名称: ${n.join(",")}`), process.exit(1)) : !0;
}, N = {
  name: "@done-coding/cli-component",
  version: "0.3.8-alpha.0",
  description: "组件命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "component"
  }
}, { namespaceDir: _, moduleName: j } = N.cliConfig, I = () => u.resolve(_, j), R = () => ({
  execDir: process.cwd(),
  templateDir: I()
}), D = (e) => {
  const { series: t, name: n } = e, o = x(h(n)), i = A(o), s = y(o), c = t ? x(h(t)) : "", l = c ? `${c}${o}` : "", r = y(l);
  return {
    series: c,
    name: o,
    nameLowerFirst: i,
    nameKebab: s,
    fullName: l,
    fullNameKebab: r,
    cls: r
  };
}, K = (e) => ({
  $: "$",
  ...R(),
  ...D(e)
}), C = () => {
  const e = u.resolve(I(), "index.json");
  if (!p.existsSync(e))
    return m.error(`模块入口文件不存在: ${e}`), process.exit(1);
  const n = JSON.parse(p.readFileSync(e, "utf-8")).config;
  if (!n)
    return m.error(`配置文件相对路径不存在: ${n}`), process.exit(1);
  const o = u.resolve(
    u.dirname(e),
    n
  );
  if (!p.existsSync(o))
    return m.error(`配置文件不存在: ${o}`), process.exit(1);
  const i = L.parse(p.readFileSync(o, "utf-8")), s = R();
  return i.componentDir = f(i.componentDir)(s), i;
}, E = (e) => {
  const { componentDir: t, nameExcludes: n } = e;
  return p.statSync(t).isDirectory() ? p.readdirSync(t).map((c) => {
    const l = u.join(t, c);
    return p.statSync(l).isDirectory() ? (console.log("filePath:", l, u.basename(l)), u.basename(l)) : "";
  }).filter((c) => !(!c || n.includes(c))) : (m.error("组件源码路径不是目录"), process.exit(1));
}, z = async () => {
  m.stage("展示列表");
  const e = C(), t = E(e);
  console.table(
    t.map((n) => {
      const { name: o, fullName: i } = D({
        ...e,
        name: n
      });
      return {
        [g.green("名称")]: o,
        [g.green("带系列名称")]: i,
        [g.green("绝对路径")]: u.resolve(e.componentDir, n)
      };
    })
  );
}, P = async ({
  name: e,
  config: t,
  command: n
}) => {
  if (![a.ADD, a.REMOVE].includes(n))
    return m.error(`不支持组件${n}操作`), process.exit(1);
  const o = K({
    ...t,
    name: e
  }), i = process.cwd(), s = JSON.stringify(o);
  for (const { entry: c, index: l } of t.list) {
    if (c) {
      const r = c;
      r != null && r.input && (r.input = f(r.input)(o)), r != null && r.output && (r.output = f(r.output)(o));
      const d = {
        ...c,
        envData: s,
        mode: $.APPEND,
        rollback: n === a.REMOVE,
        /** 回滚时可以删除空文件 */
        rollbackDelNullFile: !0,
        dealMarkdown: !0,
        batch: !1,
        rootDir: i
      };
      await O(d);
    }
    if (l) {
      const r = l;
      r != null && r.input && (r.input = f(r.input)(o)), r != null && r.output && (r.output = f(r.output)(o));
      const d = {
        ...l,
        envData: s,
        mode: $.OVERWRITE,
        rollback: n === a.REMOVE,
        dealMarkdown: !0,
        batch: !1,
        rootDir: i
      };
      await O(d);
    }
  }
}, J = async ({ name: e }) => {
  m.stage("添加组件");
  let t;
  e ? t = e : t = (await w({
    type: "text",
    name: "name",
    message: "请输入组件名"
  })).name;
  const n = C();
  T(t, n);
  const { series: o } = n, i = await E(n);
  for (let s of i)
    if (D({
      series: o,
      name: t
    }).nameKebab === s)
      return m.error(`组件${s}已存在, 不能再次创建${t}组件`), process.exit(1);
  return P({
    name: t,
    config: n,
    command: a.ADD
  });
}, Z = async ({ name: e }) => {
  m.stage("移除组件");
  const t = C(), n = await E(t);
  if (n.length === 0)
    return m.error("组件列表为空"), process.exit(1);
  let o;
  e ? o = e : o = (await w({
    type: "select",
    name: "name",
    message: "请选择要移除的组件",
    choices: n.map((s) => ({ title: s, value: s }))
  })).name;
  const { series: i } = t;
  for (let s of n)
    if (D({
      series: i,
      name: o
    }).nameKebab === s) {
      await P({
        name: o,
        config: t,
        command: a.REMOVE
      }), p.rmdirSync(u.resolve(t.componentDir, s));
      return;
    }
  return m.error(`组件${o}不存在`), process.exit(1);
}, v = async (e, t) => e === a.ADD ? J(t) : e === a.REMOVE ? Z(t) : e === a.LIST ? z() : (m.error(`无效的命令: ${e}`), process.exit(1)), {
  version: H,
  description: U,
  cliConfig: { moduleName: S }
} = N, W = {
  command: `${a.ADD} <name>`,
  describe: "新增一个组件",
  positionals: {
    name: {
      describe: "组件名称",
      type: "string"
    }
  },
  handler: b(v)(a.ADD)
}, q = {
  command: `${a.REMOVE} [name]`,
  describe: "删除一个组件",
  positionals: {
    name: {
      describe: "组件名称",
      type: "string"
    }
  },
  handler: b(v)(a.REMOVE)
}, B = {
  command: a.LIST,
  describe: "展示组件列表",
  handler: b(v)(a.LIST)
}, V = {
  describe: U,
  version: H,
  subcommands: [
    W,
    q,
    B
  ].map(M),
  demandCommandCount: 1
}, k = (e = !1) => {
  const t = e ? S : void 0, n = `$0${e ? ` ${S}` : ""} <command> [options]`;
  return { command: t, usage: n };
}, se = async () => F({
  ...V,
  ...k()
}), ae = () => M({
  ...V,
  ...k(!0)
});
export {
  ae as a,
  se as c,
  v as h
};
